/**
 * Open SUIT - Simple User Interface Toolkit
 * 
 * Copyright (c) 2009 France Telecom, http://www.francetelecom.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.ow2.opensuit.core.impl.file.fake_j2ee;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.Locale;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletResponse;

public class FakeResponse implements HttpServletResponse
{
	private ServletOutputStream _output;
	private PrintWriter _writer;
	private Locale _locale;
	private String _encoding;
	
	public FakeResponse(FileOutputStream iOutput, String iEncoding, Locale iLocale)
	{
		_encoding = iEncoding;
		_locale = iLocale;
		_output = new FakeServletOutputStream();
		try
        {
	        _writer = new PrintWriter(new OutputStreamWriter(_output, iEncoding));
        }
        catch(UnsupportedEncodingException e1)
        {
	        // TODO Auto-generated catch block
	        e1.printStackTrace();
        }
	}
	public void addCookie(Cookie arg0)
    {
	    // TODO Auto-generated method stub
	    
    }

	public void addDateHeader(String arg0, long arg1)
    {
	    // TODO Auto-generated method stub
	    
    }

	public void addHeader(String arg0, String arg1)
    {
	    // TODO Auto-generated method stub
	    
    }

	public void addIntHeader(String arg0, int arg1)
    {
	    // TODO Auto-generated method stub
	    
    }

	public boolean containsHeader(String arg0)
    {
	    // TODO Auto-generated method stub
	    return false;
    }

	public String encodeRedirectUrl(String url)
    {
		try
        {
	        return URLEncoder.encode(url, _encoding);
        }
        catch(UnsupportedEncodingException e)
        {
	        return URLEncoder.encode(url);
        }
    }

	public String encodeRedirectURL(String url)
    {
		try
        {
	        return URLEncoder.encode(url, _encoding);
        }
        catch(UnsupportedEncodingException e)
        {
	        return URLEncoder.encode(url);
        }
    }

	public String encodeUrl(String url)
    {
		try
        {
	        return URLEncoder.encode(url, _encoding);
        }
        catch(UnsupportedEncodingException e)
        {
	        return URLEncoder.encode(url);
        }
    }

	public String encodeURL(String url)
    {
		try
        {
	        return URLEncoder.encode(url, _encoding);
        }
        catch(UnsupportedEncodingException e)
        {
	        return URLEncoder.encode(url);
        }
    }

	public void sendError(int arg0, String arg1) throws IOException
    {
	    // TODO Auto-generated method stub
	    
    }

	public void sendError(int arg0) throws IOException
    {
	    // TODO Auto-generated method stub
	    
    }

	public void sendRedirect(String arg0) throws IOException
    {
	    // TODO Auto-generated method stub
	    
    }

	public void setDateHeader(String arg0, long arg1)
    {
	    // TODO Auto-generated method stub
	    
    }

	public void setHeader(String arg0, String arg1)
    {
	    // TODO Auto-generated method stub
	    
    }

	public void setIntHeader(String arg0, int arg1)
    {
	    // TODO Auto-generated method stub
	    
    }

	public void setStatus(int arg0, String arg1)
    {
	    // TODO Auto-generated method stub
	    
    }

	public void setStatus(int arg0)
    {
	    // TODO Auto-generated method stub
	    
    }

	public void flushBuffer() throws IOException
    {
	    // TODO Auto-generated method stub
	    
    }

	public int getBufferSize()
    {
	    // TODO Auto-generated method stub
	    return 0;
    }

	public String getCharacterEncoding()
    {
	    return _encoding;
    }

	public Locale getLocale()
    {
	    return _locale;
    }

	public ServletOutputStream getOutputStream() throws IOException
    {
	    return _output;
    }

	public PrintWriter getWriter() throws IOException
    {
	    return _writer;
    }

	public boolean isCommitted()
    {
	    // TODO Auto-generated method stub
	    return false;
    }

	public void reset()
    {
	    // TODO Auto-generated method stub
	    
    }

	public void resetBuffer()
    {
	    // TODO Auto-generated method stub
	    
    }

	public void setBufferSize(int arg0)
    {
	    // TODO Auto-generated method stub
	    
    }

	public void setContentLength(int arg0)
    {
	    // TODO Auto-generated method stub
	    
    }

	public void setContentType(String arg0)
    {
	    // TODO Auto-generated method stub
	    
    }

	public void setLocale(Locale arg0)
    {
	    // TODO Auto-generated method stub
	    
    }
	
	private class FakeServletOutputStream extends ServletOutputStream
	{

		@Override
        public void print(String arg0) throws IOException
        {
			_writer.print(arg0);
        }

		@Override
        public void print(boolean arg0) throws IOException
        {
	        // TODO Auto-generated method stub
			_writer.print(arg0);
        }

		@Override
        public void print(char arg0) throws IOException
        {
	        // TODO Auto-generated method stub
			_writer.print(arg0);
        }

		@Override
        public void print(int arg0) throws IOException
        {
	        // TODO Auto-generated method stub
			_writer.print(arg0);
        }

		@Override
        public void print(long arg0) throws IOException
        {
	        // TODO Auto-generated method stub
	        _writer.print(arg0);
        }

		@Override
        public void print(float arg0) throws IOException
        {
	        // TODO Auto-generated method stub
	        _writer.print(arg0);
        }

		@Override
        public void print(double arg0) throws IOException
        {
	        // TODO Auto-generated method stub
	        _writer.print(arg0);
        }

		@Override
        public void println() throws IOException
        {
	        // TODO Auto-generated method stub
	        _writer.println();
        }

		@Override
        public void println(String arg0) throws IOException
        {
	        // TODO Auto-generated method stub
	        _writer.println(arg0);
        }

		@Override
        public void println(boolean arg0) throws IOException
        {
	        // TODO Auto-generated method stub
	        _writer.println(arg0);
        }

		@Override
        public void println(char arg0) throws IOException
        {
	        // TODO Auto-generated method stub
	        _writer.println(arg0);
        }

		@Override
        public void println(int arg0) throws IOException
        {
	        // TODO Auto-generated method stub
	        _writer.println(arg0);
        }

		@Override
        public void println(long arg0) throws IOException
        {
	        // TODO Auto-generated method stub
	        _writer.println(arg0);
        }

		@Override
        public void println(float arg0) throws IOException
        {
	        // TODO Auto-generated method stub
	        _writer.println(arg0);
        }

		@Override
        public void println(double arg0) throws IOException
        {
	        // TODO Auto-generated method stub
	        _writer.println(arg0);
        }

		@Override
        public void close() throws IOException
        {
	        // TODO Auto-generated method stub
	        _writer.close();
        }

		@Override
        public void flush() throws IOException
        {
	        // TODO Auto-generated method stub
	        _writer.flush();
        }

		@Override
        public void write(byte[] b, int off, int len) throws IOException
        {
	        // TODO Auto-generated method stub
//???	        _writer.write(b, off, len);
        }

		@Override
        public void write(byte[] b) throws IOException
        {
	        // TODO Auto-generated method stub
//???	        _writer.write(b);
        }

		@Override
        public void write(int b) throws IOException
        {
	        // TODO Auto-generated method stub
	        _writer.write(b);
        }
		
	}
}
